=== debian/changelog ===
fltk1.4 (1.4.3-1ubuntu2) questing; urgency=medium

  * Back in sync with Debian, with new lto-disabled-list 58 adding it

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 May 2025 12:31:40 +0200

fltk1.4 (1.4.3-1) unstable; urgency=medium

  * Final 1.4.3 (and likely 1.4.x) release, with only formal changes
    relative to the last snapshot from Debian's perspective.
  * Upload to unstable.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 29 Apr 2025 21:00:37 -0400

fltk1.4 (1.4.3~20250423+82d5679f9cf1-2) experimental; urgency=medium

  * debian/libfltk1.4.symbols*: Go ahead with libfltk1.4.symbols.<arch>,
    with most of libfltk1.4.symbols' direct contents factored out into
    libfltk1.4.symbols.common.  Tagged inclusions mostly worked out, but
    lacked a good way to indicate that certain symbols should be present
    on 64-bit architectures and *-i386 (i.e., architectures on which
    time_t is simply long) but not anywhere else.  An additional benefit
    is being able to supply a generic fltk1.4.symbols that's open to any
    known va_list representation and to the possibility that Wayland
    support may or may not be present.
  * debian/libfltk1.4.symbols.{common,wayland}: Mark append/insertion
    vector symbols as Wayland-specific.
  * debian/rules: Drop unprefixed game manpages.  (Closes: #1104139.)
  * Standards-Version: 4.7.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 25 Apr 2025 18:17:31 -0400

fltk1.4 (1.4.3~20250423+82d5679f9cf1-1) experimental; urgency=medium

  * New upstream snapshot.
  * debian/control: Add xauth and xvfb to Build-Depends-Indep for xvfb-run.
  * debian/fltk1.4-doc.doc-base: Adjust description to note Fluid doc split.
  * debian/fltk1.4-doc.doc-base.fluid: New.
  * debian/libfltk(-gl)1.4.symbols(.[no-]wayland): Account for symbol
    differences when building without Wayland, i.e. on the Hurd.
    (Other non-Linux architectures would be in the same boat, but are off
    the radar.)
  * debian/rules: Build and install Fluid's HTML and PDF documentation
    when covering architecture-independent packages; build them under
    xvfb-run to allow for screenshot inclusion.
  * fluid/documentation/CMakeLists.txt: Adjust detailed Fluid
    documentation's installation location; install it as part of
    fltk1.4-doc for now.  (It'll get a dedicated package post-Trixie.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 23 Apr 2025 22:13:06 -0400

fltk1.4 (1.4.3~20250421+8ac2a9956-2) experimental; urgency=medium

  * debian/control: Limit libdecor build-deps to Linux too.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 22 Apr 2025 22:55:10 -0400

fltk1.4 (1.4.3~20250421+8ac2a9956-1) experimental; urgency=medium

  * New upstream release, mostly featuring build system changes, largely
    superseding the active parts of Debian's patch (which still formally
    retains changes to the traditional build system).
  * debian/control:
    - Build-depend on fluid (>= 1.4) when cross-compiling. (Closes: #1103807.)
    - Limit Wayland build dependencies to Linux per their availability.
    - libfltk1.4-dev: Stop suggesting libcairo2-dev now that it's a full
      dependency.  (See #1102961.)
  * debian/copyright: Pull out LGPL-2+ with static linking exception.
  * debian/rules: Update for new release:
    - Stop setting LD_LIBRARY_PATH now that the build uses a version of
      the fluid tool that links statically against FLTK.
    - Install fully dynamically linked versions of tools.
    - Move games from debian/tmp/usr/bin rather than copying them directly
      from under obj-*.
    - Install glpuzzle.man as flpuzzle.6 with appropriate substitutions.
    - Adjust override_dh_auto_install-indep's logic to wipe out all of
      debian/tmp/usr/bin but run at all only in the absence of
      .../usr/bin/fluid.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 22 Apr 2025 22:10:52 -0400
