=== debian/rules ===
#!/usr/bin/make -f
XCFLAGS = -Wall -Wunused -Wno-format-y2k -fPIE -fno-strict-aliasing -DCP936 \
	  -fvisibility-inlines-hidden

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(XCFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(XCFLAGS)

DPKG_EXPORT_BUILDFLAGS = yes
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

GAMES = blocks checkers sudoku

FLTK_CONFIG = $(DEB_HOST_GNU_TYPE)-fltk-config
PKG_CONFIG = /usr/bin/$(DEB_HOST_GNU_TYPE)-pkg-config
export PKG_CONFIG

cmake_out = obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@ --buildsystem=cmake

override_dh_autoreconf:;
override_dh_autoreconf_clean:;
override_dh_update_autotools_config:;

override_dh_clean:
	dh_clean
	chmod +x debian/fix-fltk-* debian/fltk-config

INDEP = FLUID_DOCS LINKS HTML_DOCS PDF_DOCS

override_dh_auto_configure:
	if dh_listpackages | grep -q doc; then \
	    install_indep="$(INDEP:%=-DFLTK_INSTALL_%:BOOL=ON)"; \
	    install_indep="$$install_indep -DFLTK_BUILD_FLUID_DOCS:BOOL=ON"; \
	else \
	    install_indep=; \
	fi; \
	dh_auto_configure -- \
            -DFLTK_OPTION_CAIRO_EXT:BOOL=ON -DFLTK_BUILD_SHARED_LIBS:BOOL=ON \
	    $$install_indep -DCMAKE_SKIP_RPATH:BOOL=ON \
            -DCMAKE_HAVE_THREADS_LIBRARY:BOOL=ON -DFLTK_OPTION_STD:BOOL=ON
	find $(cmake_out)/CMakeFiles/Export -name FLTK-Targets.cmake \
	    -exec debian/fix-fltk-targets debian/FLTK-Targets-head.cmake \
	    {} \; > $(cmake_out)/etc/FLTK-Targets.cmake
	find $(cmake_out)/CMakeFiles/Export -name FLTK-Targets-none.cmake \
	    -exec debian/fix-fltk-targets {} \
	    debian/FLTK-Targets-none-tail.cmake \; \
	    > $(cmake_out)/etc/FLTK-Targets-none.cmake
	sed -e '/^endif/q' $(cmake_out)/FLTKConfigVersion.cmake \
	    > $(cmake_out)/etc/FLTKConfigVersion.cmake
	grep '^add_' $(cmake_out)/etc/FLTK-Targets.cmake
	grep 'check_targets' $(cmake_out)/etc/FLTK-Targets-none.cmake

override_dh_auto_build-indep:
	dh_auto_build -i
	xvfb-run -a $(MAKE) -C $(cmake_out) docs fluid_pdf

override_dh_auto_install-arch:
	dh_auto_install -a
	for x in debian/tmp/usr/bin/*-shared; do \
	    mv -fv $$x $${x%-shared}; \
	done
	mkdir -p debian/tmp/usr/games
	mkdir -p debian/tmp/usr/share/applications
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/128x128/apps
	mkdir -p debian/tmp/usr/share/man/man6
	mkdir -p debian/tmp/usr/share/pixmaps
## fltk1.4-games (installed by hand to be able to add fl prefixes.)
	for game in $(GAMES); do \
	    mv -fv debian/tmp/usr/bin/$$game debian/tmp/usr/games/fl$$game && \
	    sed -e 's,Exec=,&/usr/games/fl,; s,Icon=,&fl,; s,Name=,&FLTK ,' \
	      test/desktop/$$game.desktop \
	      >debian/tmp/usr/share/applications/fl$$game.desktop && \
	    cp test/desktop/$$game-32.png \
	      debian/tmp/usr/share/icons/hicolor/32x32/apps/fl$$game.png && \
	    cp test/desktop/$$game-128.png \
	      debian/tmp/usr/share/icons/hicolor/128x128/apps/fl$$game.png && \
	    sed -e '1s,^\.TH ,&fl,; 3s,^,fl,' documentation/src/$$game.man \
	      >debian/tmp/usr/share/man/man6/fl$$game.6 \
	    || exit 1; \
	done
	mv debian/tmp/usr/bin/glpuzzle debian/tmp/usr/games/flpuzzle
	sed -e '1s,^\(\.TH \)gl,\1fl,; 3s,^gl,fl,; s/fIglpuzzle/fIflpuzzle/g' \
	  documentation/src/glpuzzle.man \
	  >debian/tmp/usr/share/man/man6/flpuzzle.6
	rm -fv debian/tmp/usr/share/man/man6/[!f]*.6
	cp -fv $(cmake_out)/etc/*.cmake debian/tmp/usr/share/fltk/
	debian/fix-fltk-config $(cmake_out)/fltk-config \
	    > debian/tmp/usr/bin/$(FLTK_CONFIG)
	chmod 755 debian/tmp/usr/bin/$(FLTK_CONFIG)
	rm -f debian/tmp/usr/bin/fltk-config

override_dh_auto_install-indep:
	if [ ! -f debian/tmp/usr/bin/fluid ]; then \
	    dh_auto_install -i && \
	    rm -fv debian/tmp/usr/bin/* ; \
	fi

override_dh_installdocs:
	dh_installdocs -A CREDITS.txt README.txt

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.txt
	for x in debian/*/usr/share/doc/*/changelog; do \
	    mv -v $$x `dirname $$x`/NEWS; \
	done

override_dh_installman-arch:
	dh_installman
	ln -snfv fltk-config.1 \
	    debian/libfltk1.4-dev/usr/share/man/man1/$(FLTK_CONFIG).1

override_dh_missing-arch:
	cd debian/tmp  &&  for x in usr/share/man/*/*; do \
	    if [ -f ../*/$$x.gz ]; then rm -f $$x; fi \
	done
	dh_missing -Xusr/include/Fl

override_dh_missing-indep:
	dh_missing -Xusr/include/Fl -Xusr/share/man

override_dh_shlibdeps-arch:
	dh_shlibdeps -Nfltk1.4-games
	dh_shlibdeps -pfltk1.4-games -Xflpuzzle -- -dRecommends \
	    debian/fltk1.4-games/usr/games/flpuzzle -dDepends
